# -*- coding: utf-8 -*-
""" callback

"""
from constant import UNDEF_ID
from dbsvc import CALLBACK_ERRORS
from gluon import current


def INHIBIT_DELETE_UNDEF(set):
    """Delete the row containing undefined value is not allowed

    Args:
        set (gluon.dal.Set):

    Returns:
        bool:

    """
    db, T = current.globalenv['db'], current.T
    field = set.query.first

    # protection
    # the query of the set should be "table.id == 1"
    if field._db._adapter.EQ != set.query.op:
        return False

    # inhibit the delete
    if field.name == 'id' and set.query.second == UNDEF_ID:
        field._table[CALLBACK_ERRORS] = \
        T("You can not delete the row containing the undefined value.")
        return True

    return False


def INHIBIT_UPDATE_UNDEF(set, values):
    """Update the row containing undefined value is not allowed

    Args:
        set (gluon.dal.Set):

    Returns:
        bool:

    """
    db, T = current.globalenv['db'], current.T
    field = set.query.first

    # protection
    # the query of the set should be "table.id == 1"
    if set.query.op != field._db._adapter.EQ:
        return False

    # inhibit the delete
    if field.name == 'id' and int(set.query.second) == UNDEF_ID:
        field._table[CALLBACK_ERRORS] = \
        T("You can not update the row containing the undefined value.")
        return True

    return False
