""" a collection of filters

"""
import re

REG_COMMA = re.compile(r'( *, *)+$')

def CLEAN_COMMA(value):
    """Remove trailing comma(s).
    Search patterns are: ',' or ', ' or ' ,, ' ...

    Args:
        value (str or unicode):

    Returns:
        str or unicode:
            the return the value is unchanged when it is not a string.

    """
    if not isinstance(value, (str, unicode)):
        return value

    return re.sub(REG_COMMA, '', value)


def CLEAN_SPACES(value):
    """Remove leading as well as trailing spaces and keep a single space
    between words.

    Args:
        value (str or unicode):

    Returns:
        str or unicode:
            the return the value is unchanged when it is not a string.

    """
    if not isinstance(value, (str, unicode)):
        return value

    return ' '.join(value.strip().split())
